#!/usr/bin/ruby -w
# See the LICENSE file for copyright and distribution information

require "mkmf"

$LIBPATH.push(Config::CONFIG['libdir'])

def crash(str)
  printf(" extconf failure: %s\n", str)
  exit 1
end

#dir_config('xml2')
#dir_config('xslt')

#unless have_library('m', 'atan')
#  crash('need libm')
#end

unless have_library("z", "inflate")
  crash("need zlib")
else
  $defs.push('-DHAVE_ZLIB_H')
end

#if dir_config( "xml2" ) != [nil, nil]
#   inc, lib = dir_config( 'xml2' ) 
#   $LDFLAGS << " -L#{lib} -lxml2 -lz -lpthread -liconv -lm"
#   $CFLAGS << " -I#{inc}"
#elsif ex = find_executable( "xml2-config" )
#   $LDFLAGS << ' ' + `#{ex} --libs`.chomp
#   $CFLAGS << ' ' + `#{ex} --cflags`.chomp
#else
#  crash(<<EOL)
#need libxml2.
#
#        Install the library or try one of the following options to extconf.rb:
#
#        --with-xml2-lib=/path/to/libxml2/lib
#        --with-xml2-include=/path/to/libxml2/include
#EOL
#end

if dir_config( "xslt" ) != [nil, nil]
   inc, lib = dir_config( 'xslt' ) 
   $LDFLAGS << " -L#{lib} -lxslt -lxml2 -lz -lpthread -liconv -lm"
   $CFLAGS << " -I#{inc}"
elsif ex = find_executable( "xslt-config" )
   $LDFLAGS << ' ' + `#{ex} --libs`.chomp
   $CFLAGS << ' ' + `#{ex} --cflags`.chomp
else
  crash(<<EOL)
need libxslt.

        Install the library or try one of the following options to extconf.rb:

        --with-xslt-lib=/path/to/libxslt/lib
        --with-xslt-include=/path/to/libxslt/include
EOL
end

$CFLAGS = '-g -Wall' + $CFLAGS

puts "compile with : "
puts "  CFLAGS = #{$CFLAGS}"
puts "  LDFLAGS = #{$LDFLAGS}"
puts

create_header()
create_makefile("xml/xslt")
